''  con_buf.bas
''	Copyright (C) 2005-2007 Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.
''

#include "con_buf.bi"

#define TRUE  1
#define FALSE 0

public Sub conbuf_clear alias "conbuf_clear" ( ByVal conbuffer As CONBUFFER_T Ptr )
	If (conbuffer) Then
		Dim p As UByte Ptr = conbuffer->dataptr
		If (p) Then
			Dim count As Integer = conbuffer->size
			while (count)
				count -= 1
				*p = 0
				p += 1
			wend
		End If
		conbuffer->col = 0
		conbuffer->row = 0
		conbuffer->changed = TRUE
	End If
End Sub

public Sub conbuf_text alias "conbuf_text" ( ByVal conbuffer As CONBUFFER_T Ptr, ByVal txt As UByte ptr )
	Dim c As UByte Ptr = txt
	Dim cr As Integer = FALSE
	conbuffer->changed = TRUE

	while(*c)
		Select Case (*c)
			case 13
				conbuffer->col = 0
				cr = TRUE
			case 10
				conbuffer->col = 0
			case else
				conbuffer->dataptr[conbuffer->row * conbuffer->maxcol + conbuffer->col] = *c
				conbuffer->col += 1
				if(conbuffer->col>=conbuffer->maxcol) Then
					conbuffer->col=0
					cr = TRUE
				end if
		End Select

		if(cr) Then
			cr = FALSE
			conbuffer->row += 1      
			if (conbuffer->row >= conbuffer->maxrow) Then
				Dim dst As UByte Ptr = conbuffer->dataptr
				Dim src As UByte Ptr = conbuffer->dataptr + conbuffer->maxcol
				Dim count As Integer = (conbuffer->maxrow-1)*conbuffer->maxcol
				while (count)
					count -= 1
					*dst = *src
					dst += 1
					src += 1
				wend
				count = conbuffer->maxcol
				while (count)
					count -= 1
					*dst = 0
					dst += 1
				wend
				conbuffer->row -= 1
			End If
		End If
		c += 1
	wend
End Sub

public Function conbuf_resize alias "conbuf_resize" ( ByVal conbuffer As CONBUFFER_T Ptr, ByVal rows As Integer, Byval cols As Integer) as integer
	''FIXME: preserve data
	conbuffer->maxrow = rows
	conbuffer->maxcol = cols
	conbuf_clear conbuffer
	Function = TRUE
End Function
