#ifndef _INCLUDE_CON_BUF_H
#define _INCLUDE_CON_BUF_H

/*
''  Copyright (C) 2005-2007, Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.
*/

#ifndef __stdcall
#define __stdcall __attribute__((stdcall))
#endif

typedef struct {
  int maxrow;     // max rows
  int maxcol;     // max columns
  int row;        // current row
  int col;        // current col
  int size;       // size of console in bytes
	int changed;     // set to TRUE if changed
  char * dataptr; // pointer to console data
} CONBUFFER_T;

void __stdcall conbuf_clear( CONBUFFER_T conbuffer );
void __stdcall conbuf_text( CONBUFFER_T conbuffer, char * txt );
int __stdcall conbuf_resize( CONBUFFER_T conbuffer, int rows, int cols );

#endif
