#ifndef _INCLUDE_JM_CON_H
#define _INCLUDE_JM_CON_H

/*
''  Copyright (C) 2005-2007, Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.
*/

#ifndef __stdcall
#define __stdcall __attribute__((stdcall))
#endif

#define CON_DEBUG_ENABLE    1
#define CON_DEBUG_REDIR     2
#define CON_DEBUG_BOTH      4

int __stdcall CON_getecho( void );
int __stdcall CON_setecho( int echo );
int __stdcall CON_getdebug( void );
int __stdcall CON_setdebug( int flag );
void __stdcall CON_setlogfile( const char * f );
const char * __stdcall CON_getlogfile( void );

void __stdcall CON_clear( void );
void __stdcall CON_print(const char *txt);
void __stdcall CON_print_dbg(const char *txt);
void __stdcall CON_print1(const char *format, ...);
void __stdcall CON_print1_dbg(const char *format, ...);
void CON_printf(const char *format, ...);
void CON_printf_dbg(const char *format, ...);

char * __stdcall CON_data( void );
int __stdcall CON_maxrow( void );
int __stdcall CON_maxcol( void );

int __stdcall CON_resize(int cols, int rows);

#endif
