''  jm_font_fbgfx.bas - jm_font
''	Copyright (C) 2005-2007 Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.
''

#include "inc1/jm_font_rt.bi"
#include "jm_font.bi"
#include "fbgfx.bi"
#include "jm_boxes_color.bi"

using fb

' =================
' Methods
' =================

private Sub fonti_Delete alias "fonti_Delete" (byval fnt As JM_FONT_PTR)
	If (fnt) Then
		if (fnt->glyphdata) then deallocate   fnt->glyphdata
		if (fnt->chardata)  then deallocate   fnt->chardata
	End If
End Sub

private Function fonti_GetCharAdvanceX alias "fonti_GetCharAdvanceX" (byval fnt As JM_FONT_PTR, byval ch as integer) As Integer
	if (fnt) then
		function = fnt->w
	end if
End Function

private Function fonti_GetCharAdvanceY alias "fonti_GetCharAdvanceY" (byval fnt As JM_FONT_PTR, byval ch as integer) As Integer
	if (fnt) then
		function = fnt->h
	end if
End Function


private function blender_transfont ( byval source_pixel as uinteger, byval destination_pixel as uinteger, byval parameter as any ptr) as uinteger
	if( source_pixel and &hffffff ) then
		return *cast(uinteger ptr, parameter)
	end if
	return destination_pixel
end function

private function fonti_DrawChar alias "fonti_DrawChar" (byval fnt As JM_FONT_PTR, ByVal x as Integer, ByVal y as Integer, ByVal ch as Integer, ByVal fc as Integer, ByVal bc as Integer, byval trans as integer) as integer
	dim glyptr as any ptr
	function = 0
	If (fnt) Then
		function = fnt->w
		If (fnt->glyphdata) then
			glyptr = Cast(byte ptr, fnt->glyphdata) + fnt->bpglyph * (ch and 255)
			if trans = 0 then
				Line (x,y)-(x + fnt->w - 1, y + fnt->h - 1), bc, bf
			end if
			put (x, y), glyptr, CUSTOM, @blender_transfont, @fc
		End If
	End If
End Function

' =================
' Font Creation
' =================

Function FONT_CreateFromBMP alias "FONT_CreateFromBMP" (ByVal w As Integer, ByVal h As Integer, byval strFile As zString ptr) As JM_FONT_PTR
	Dim tmp As Any Ptr, fnt As JM_FONT_PTR = 0
	dim pal(0 to 255) as uinteger
	tmp = ImageCreate(w * 16, h * 16)
	if (tmp) Then
		if( UI_GetColorDepth() = 8 ) then
			if Bload(*strFile, tmp, @pal(0) ) = 0 then
				fnt = FONT_CreateFromImage(w, h, tmp)
			end if
		else
			if Bload(*strFile, tmp ) = 0 then
				fnt = FONT_CreateFromImage(w, h, tmp)
			end if
		end if
		ImageDestroy tmp
	End If
	return fnt
End Function

function FONT_CreateFromImage alias "FONT_CreateFromImage" (ByVal w As Integer, ByVal h As Integer, ByVal img as Any Ptr) As JM_FONT_PTR
	Dim i as Integer, tmp as IMAGE Ptr, sx As Integer, sy As Integer, glyptr As IMAGE Ptr
	dim j as integer
	dim p as byte ptr
	Dim fnt As JM_FONT_PTR
	fnt = Allocate(sizeof(JM_FONT_T))

	fnt->typ = JM_FONT_TYPE_BITMAP
	fnt->w = w
	fnt->h = h
	fnt->bpchar = 0
	fnt->chardata = 0

	tmp = ImageCreate(w,h)

	fnt->bpglyph = sizeof(IMAGE) + h * tmp->pitch
	fnt->glyphdata = callocate(256 * fnt->bpglyph)

	fnt->handle = 0
	For i = 0 to 255
		glyptr = Cast( IMAGE ptr, Cast(Byte Ptr,fnt->glyphdata) + i * fnt->bpglyph)
		sx = (i Mod 16) * w
		sy = (i  \  16) * h

		*cast(IMAGE ptr, glyptr ) = *tmp
		Get img, (sx, sy)-(sx + w-1,sy + h-1), glyptr

	Next i

	ImageDestroy tmp

	fnt->pfnDelete = @fonti_Delete
	fnt->GetCharAdvanceX = @fonti_GetCharAdvanceX
	fnt->GetCharAdvanceY = @fonti_GetCharAdvanceY
	fnt->DrawChar = @fonti_DrawChar
	Return fnt

end function
