#ifndef __INCLUDE_JM_FONT_H__
#define __INCLUDE_JM_FONT_H__

/*
''  Copyright (C) 2005-2007, Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.
*/

#ifndef __stdcall
#define __stdcall __attribute__((stdcall))
#endif

typedef enum {
	JM_FONT_TYPE_BITMAP = 0
	JM_FONT_TYPE_VARBITMAP = 1
	JM_FONT_TYPE_TTF = 2
}	JM_FONT_TYPES;

#ifndef JM_FONT_PTR_DEFINED
#define JM_FONT_PTR_DEFINED
typedef void * JM_FONT_PTR
#endif

JM_FONT_PTR __stdcall FONT_CreateFromImage (int w, int h, void * img);
JM_FONT_PTR __stdcall FONT_CreateFromBMP (int w, int h, char * strfile);
JM_FONT_PTR __stdcall FONT_CreateFromPNG (int w, int h, char * strfile);
JM_FONT_PTR __stdcall FONT_CreateFromTTF (int h, char * strfile);
JM_FONT_PTR __stdcall FONT_CreateFromFNT (char * strfile);

JM_FONT_PTR __stdcall FONT_Get ();
JM_FONT_PTR __stdcall FONT_Set (JM_FONT_PTR fnt);
void        __stdcall FONT_Delete (JM_FONT_PTR fnt);

int __stdcall FONT_GetTextWidthN (char * s, int nbytes);
int __stdcall FONT_GetTextWidth (char * s);

int __stdcall FONT_GetTextHeightN (char * s, int nbytes);
int __stdcall FONT_GetTextHeight (char * s);

int __stdcall FONT_GetCharAdvanceX (int ch);
int __stdcall FONT_GetCharAdvanceY (int ch);

int __stdcall FONT_GetIndexFromX (char * s, int nbytes, int startindex, int xpos);
int __stdcall FONT_GetMaxChars (char * s, int nbytes, int w );

int __stdcall FONT_DrawChar (int x, int y, int ch, int forecolor, int backcolor, int trans);
int __stdcall FONT_DrawStringN (int x, int y, char * txt, int nbytes, int forecolor, int backcolor, int trans);
int __stdcall FONT_DrawString (int x, int y, char * txt, int forecolor, int backcolor, int trans);

extern JM_FONT_PTR FONT_curfnt;

#endif
