''  jm_font_yagl_fixed_bm.bas - jm_font
''	Copyright (C) 2005-2007 Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.
''

Type JM_FONT_CHAR_T field = 1
	c0 as ubyte           '' ascii character
	c1 as ubyte           '' '\0'
	c2 as ubyte           '' '\0'
	c3 as ubyte           '' '\0'
	cax as short          '' glyph advance width
	cay as short          '' glyph advance width
	cbx as short          '' glyph bearing left
	cby as short          '' glyph bearing top
End Type
#define JM_FONT_CHAR_T_DEFINED

#include "inc1/jm_font_rt.bi"
#include "jm_font.bi"
#include "yaglwrapper.bi"

#define mBLEND 1.0

' =================
' TTF Methods
' =================

private Sub fonti_Delete alias "fonti_Delete" (byval fnt As JM_FONT_PTR)
	Dim i as Integer
	If (fnt) Then
		if (fnt->tmpch)     then deallocate   fnt->tmpch
		if (fnt->glyphdata) then deallocate   fnt->glyphdata
		if (fnt->chardata)  then deallocate   fnt->chardata
		YaglGfxDevice_destroyFont Cast(YaglGfxSurface, fnt->handle)
	End If
End Sub

private Function fonti_GetCharAdvanceX alias "fonti_GetCharAdvanceX" (byval fnt As JM_FONT_PTR, byval ch as integer) As Integer
	If (fnt) Then
		function = fnt->chardata[ch and 255].cax
	end if
End Function

private Function fonti_GetCharAdvanceY alias "fonti_GetCharAdvanceY" (byval fnt As JM_FONT_PTR, byval ch as integer) As Integer
	If (fnt) Then
		function = fnt->chardata[ch and 255].cay
	end if
End Function

private Function fonti_DrawChar alias "fonti_DrawChar" (byval fnt As JM_FONT_PTR, ByVal x as Integer, ByVal y as Integer, ByVal ch as Integer, ByVal foreColor as Integer, ByVal backColor as Integer, ByVal trans as integer) as integer
	function = 0
	If (fnt) Then
		YaglGfxDevice_printAt cast(zstring ptr, fnt->chardata + (ch and 255)), x, y,foreColor,Cast(YaglGfxSurface, fnt->handle),1.0
		function = fnt->chardata[ch and 255].cax
	End If
End function

' =================
' Font Creation
' =================

Function FONT_CreateFromTTF alias "FONT_CreateFromTTF" (ByVal h As Integer, byval strFile As zString ptr) As JM_FONT_PTR
	Dim fnt As JM_FONT_PTR, i as integer
	fnt = Allocate(sizeof(JM_FONT_T))
	fnt->typ = JM_FONT_TYPE_TTF
	fnt->w = 0
	fnt->h = h
	fnt->bpchar = sizeof(JM_FONT_CHAR_T)
	fnt->chardata = Allocate(256 * fnt->bpchar)
	fnt->bpglyph = 0
	fnt->glyphdata = 0
	fnt->tmpch = 0
	fnt->handle = Cast(Integer, YaglGfxDevice_CreateFont())
	YaglGfxFont_loadFont(Cast(YaglGfxFont, fnt->handle), strFile)
	YaglGfxFont_setSize(Cast(YaglGfxFont, fnt->handle), h)
	for i = 0 to 255
		with fnt->chardata[i]
			.c0 = i
			.c1 = 0
			.c2 = 0
			.c3 = 0
			.cax = YaglGfxFont_getAdvance( Cast(YaglGfxFont, fnt->handle), i )
			.cay = h
			.cbx = YaglGfxFont_getLeft( Cast(YaglGfxFont, fnt->handle), i )
			.cby = 0
		end with
	next i
	fnt->Delete = @fonti_Delete
	fnt->GetCharAdvanceX = @fonti_GetCharAdvanceX
	fnt->GetCharAdvanceY = @fonti_GetCharAdvanceY
	fnt->DrawChar = @fonti_DrawChar
	return fnt
End Function
