''  jm_font_yagl_fixed_bm.bas - jm_font
''	Copyright (C) 2005-2007 Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.
''

Type JM_FONT_CHAR_T field = 1
	handle as integer     '' extra handle (or memory pointer to glyph pixel data)
End Type
#define JM_FONT_CHAR_T_DEFINED

#include "inc1/jm_font_rt.bi"
#include "jm_image.bi"
#include "jm_font.bi"
#include "yaglwrapper.bi"

#define mBLEND 1.0

' =================
' Fixed BMP Methods
' =================

private Sub fonti_Delete alias "fonti_Delete" (byval fnt As JM_FONT_PTR)
	Dim i as Integer
	If (fnt) Then
		for i = 0 to 255	
			YaglGfxDevice_destroySurface fnt->chardata[i].handle
		next i
	End If
End Sub

private Function fonti_GetCharAdvanceX alias "fonti_GetCharAdvanceX" (byval fnt As JM_FONT_PTR, byval ch as integer) As Integer
	if (fnt) then
		function = fnt->w
	end if
End Function

private Function fonti_GetCharAdvanceY alias "fonti_GetCharAdvanceY" (byval fnt As JM_FONT_PTR, byval ch as integer) As Integer
	if (fnt) then
		function = fnt->h
	end if
End Function

Function fonti_DrawChar alias "fonti_DrawChar" (byval fnt As JM_FONT_PTR, ByVal x as Integer, ByVal y as Integer, ByVal ch as Integer, ByVal foreColor as Integer, ByVal backColor as Integer, ByVal trans as integer) as integer
	Dim prevTinting as integer
	function = 0
	If (fnt) Then
		prevTinting = YaglGfxDevice_getTintingColor()
		YaglGfxDevice_setTintingColor(forecolor)
		YaglGfxDevice_blit x, y, fnt->chardata[ch and 255].handle, BLIT_ALPHAMASKED, mBLEND
		YaglGfxDevice_setTintingColor(prevtinting)
		function = fnt->w
	End If
End function

' =================
' Font Creation
' =================

Function FONT_CreateFromImage alias "FONT_CreateFromImage" (ByVal w As Integer, ByVal h As Integer, ByVal img as Any Ptr) As JM_FONT_PTR
	Dim as Integer i, j, sx, sy, x, y
	Dim tmp as Any Ptr, c as integer ptr
	Dim fnt As JM_FONT_PTR
	Dim t As Any Ptr = IMAGE_Create(w, h, 0, 32)
	fnt = Allocate(sizeof(JM_FONT_T))
	fnt->typ = JM_FONT_TYPE_BITMAP
	fnt->w = w
	fnt->h = h
	fnt->bpchar = sizeof(JM_FONT_CHAR_T)
	fnt->chardata = Allocate(256 * fnt->bpchar)
	fnt->bpglyph = 0
	fnt->glyphdata = 0
	fnt->tmpch = 0
	For i = 0 to 255
		sx = (i Mod 16) * w
		sy = (i  \  16) * h
		for y = 0 to h - 1
			for x = 0 to w - 1
				IMAGE_pset t, x, y, IMAGE_pget(img, sx + x, sy + y)
			next x
		next y
		c = t
		for j = 1 to w*h
			if (c[j]) then	c[j] OR= &HFF00000
		next j				
		fnt->chardata[i].handle = YaglGfxDevice_createSurface()
		YaglGfxSurface_loadFromMemory(fnt->chardata[i].handle, Cast(byte ptr, t) + 4, w, h, BITMAP_FORMAT_ARGB32)
	Next i
	IMAGE_Destroy t
	Return fnt
End Function

Function FONT_CreateFromBMP alias "FONT_CreateFromBMP" (ByVal w As Integer, ByVal h As Integer, byval strFile As zString ptr) As JM_FONT_PTR
	Dim tmp As Any Ptr, fnt As JM_FONT_PTR = 0
	tmp = IMAGE_LoadFile(strFile, 32)
	if (tmp) Then
		fnt = FONT_CreateFromImage(w, h, tmp)
		IMAGE_Destroy tmp
	end if
	fnt->Delete = @fonti_Delete
	fnt->GetCharAdvanceX = @fonti_GetCharAdvanceX
	fnt->GetCharAdvanceY = @fonti_GetCharAdvanceY
	fnt->DrawChar = @fonti_DrawChar
	return fnt
End Function
