''  jm_boxes_std_edit.bas - jm_gui
''	Copyright (C) 2005-2007 Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.
''

#include "inc1/jm_gui_rt.bi"
#include "jm_gui_base.bi"
#include "jm_boxes.bi"
#include "../jm_font/jm_font.bi"
#include "jm_boxes_std_edit.bi"
#include "../jm_string/jm_string.bi"

'' -------------------------------------------------------------------
'' BOX CREATION
'' -------------------------------------------------------------------

Function UI_CreateEdit alias "UI_CreateEdit" (ByVal ownerbox As UI_BOX_PTR, byval id As integer, _
	byval x As Integer, byval y As Integer, byval w As Integer, byval h As Integer, _
	ByVal BoxProc As BOXPROC_FUNC_T, ByVal flags As Integer, byval strCaption As zstring ptr) As UI_BOX_PTR
	Dim tmp As UI_BOX_PTR
	tmp = UI_CreateBox(ownerbox, UI_BOX_EDIT, id, x, y, w, h, BoxProc, @UI_DefEditProc_cb, sizeof(UI_EDIT_T), flags)
	If (tmp) Then
		Dim d As UI_EDIT_T Ptr = UI_GetBoxExtraBytesPtr(tmp)
		dim b as EDIT_BUFFER_T Ptr
		b = d->buffer
		EDIT_BUFFER_SetText(b,strCaption, zstr_Len(strCaption))
		''EDIT_BUFFER_SetText(d->buffer,strCaption, zstr_Len(strCaption))  '' Why problem on Linux
		EDIT_BUFFER_ClearChanged(d->buffer)
	End If
	return tmp
End Function

'' -------------------------------------------------------------------
'' DEFAULT BOXPROCS
'' -------------------------------------------------------------------

Private sub UpdatePosition alias "UpdatePosition" (byval r As UI_RECT_T Ptr, ByVal d As UI_EDIT_T Ptr, byval mx as integer, byval my as integer)
	dim cx as integer, cy as integer, xchars as integer
	UI_InflateRect r, -1, -1
	cx = FONT_GetTextWidth("M")
	cy = FONT_GetTextHeight("M")
	xchars = (r->w - (r->w mod cx)) \ cx - 1
	if xchars <= 0 then xchars = 1
	EDIT_BUFFER_SetIndex(d->buffer, d->leftindex + ((mx + cx \ 2) \ cx))
end sub

Function UI_DefEditProc_cb alias "UI_DefEditProc_cb"  (ByVal box As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer
	Dim r As UI_RECT_T
	Dim d As UI_EDIT_T Ptr = UI_GetBoxExtraBytesPtr(box)
	dim cx as integer, cy as integer
	dim nx as integer, ny as integer, xchars as integer, ychars as integer

	If (UI_CallBoxProc(box, msgid, msgdata)) Then

		Select Case msgid
		Case UI_MSG_CREATE
			d->flags = 0
			d->buffer = EDIT_BUFFER_Create(1024)
			d->leftindex = 0
			d->topindex = 0
		
		Case UI_MSG_DESTROY
			EDIT_BUFFER_Destroy d->buffer
			d->buffer = 0
		
		Case UI_MSG_PAINT
			UI_GetScreenCoords box, @r

			UI_DrawFrame @r, UI_FS_EDIT

			UI_InflateRect @r, -1, -1
			cx = FONT_GetTextWidth("M")
			cy = FONT_GetTextHeight("M")
			xchars = (r.w - (r.w mod cx)) \ cx - 1
			if xchars <= 0 then xchars = 1
			ychars = (r.h - (r.h mod cy)) \ cy - 1
			if ychars <= 0 then ychars = 1

#if 0

'' TODO: this is not even close to being completed!!!
'' (just a copy from STD_INPUT just now

			if d->buffer->mlength <= xchars then
				d->leftindex = 0
			elseif d->buffer->mindex = d->buffer->mlength then
				d->leftindex = d->buffer->mlength - xchars
			else
				if d->buffer->mindex < d->leftindex + 1 then
					if d->buffer->mindex < xchars then
						d->leftindex = 0
					else
						d->leftindex = d->buffer->mindex - xchars \ 2
					end if
				elseif d->buffer->mindex > d->leftindex + xchars then
					d->leftindex = d->buffer->mindex - xchars + xchars \ 2
				end if
			end if

			nx = xchars
			if (d->buffer->mlength - d->leftindex) < xchars then
				n = d->buffer->mlength - d->leftindex
			end if

			if d->buffer->mlength > xchars then
				UI_DrawText @r, d->buffer->mdata + d->leftindex, n, UI_GetSysColor(UI_SYSCLR_TEXT), UI_GetSysColor(UI_SYSCLR_FRAME_FACE), UI_TEXT_ALIGN_LEFT
			else
				UI_DrawText @r, d->buffer->mdata + d->leftindex, d->buffer->mlength, UI_GetSysColor(UI_SYSCLR_TEXT), UI_GetSysColor(UI_SYSCLR_FRAME_FACE), UI_TEXT_ALIGN_LEFT ''UI_TEXT_ALIGN_CENTER
			end if

			if UI_GetFocus() = box then
				dim xx = r.x + (d->buffer->mindex - d->leftindex) * cx
				dim yy = r.y
				UI_DrawCaret xx,yy,cx,cy,UI_GetSysColor(UI_SYSCLR_TEXT)
			end if

		case UI_MSG_MOUSE_DOWN
			if UI_GetCapture = NULL then
				UI_SetCapture box
				UpdatePosition @r, d, msgdata->mx, msgdata->my
			end if
		case UI_MSG_MOUSE_UP
			if UI_GetCapture() = box then
				UpdatePosition @r, d, msgdata->mx, msgdata->my
			end if
			UI_ReleaseCapture
		case UI_MSG_MOUSE_MOVE
			if UI_GetCapture() = box then
				UpdatePosition @r, d, msgdata->mx, msgdata->my
			end if

		Case UI_MSG_KEYPRESS
			dim buf as EDIT_BUFFER_T Ptr = d->buffer
			dim ch as integer = msgdata->ky
			Select case ch
			case KEY_LEFT
				if buf->mindex > 0 then buf->mindex -= 1
			case KEY_RIGHT
				''if buf->mindex < buf->mlength then buf->mindex += 1
			case KEY_HOME
				if buf->mindex > 0 then	buf->mindex = 0
			case KEY_END
				''if buf->mindex < buf->mlength then buf->mindex = buf->mlength
			case KEY_BACK
				EDIT_BUFFER_BackChar buf
			''case KEY_INSERT
			case KEY_DELETE
				EDIT_BUFFER_DeleteChar buf
			case 32 to 126
				EDIT_BUFFER_InsertChar buf, ch
			case else
				return 1
			end select


#endif

		Case Else
			return 1
		End Select
	else
	  return 1 '' Msg not processed
	End If
End Function


