''  jm_edit_buffer.bas - jm_gui
''	Copyright (C) 2005-2007 Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.
''

#include "jm_edit_buffer.bi"

/'
Type EDIT_BUFFER_T
	mbuffer as GAP_BUFFER_T ptr
	mcurrow as integer
	mrowcount as integer
	mmaxrows as integer
End Type
'/

function EDIT_BUFFER_Create alias "EDIT_BUFFER_Create" (byval startsize as integer) as EDIT_BUFFER_T Ptr
	dim buf as EDIT_BUFFER_T Ptr
	buf = Allocate(sizeof(GAP_BUFFER_T))
	if (buf) then
		buf->mBuffer = GAP_BUFFER_Create(startsize)
		if( buf->mBuffer ) then
			buf->mcurrow = 0	
			buf->mrowcount = 0
			buf->mmaxrows = 0
		else
			Deallocate buf
			buf = 0
		end if
	end if
	function = buf
end function

sub EDIT_BUFFER_Destroy alias "EDIT_BUFFER_Destroy" (byval buf as EDIT_BUFFER_T Ptr)
	if( buf ) then
		GAP_BUFFER_Destroy( buf->mBuffer )
		deallocate buf
	end if
end sub

sub EDIT_BUFFER_Clear alias "EDIT_BUFFER_Clear" (byval buf as EDIT_BUFFER_T Ptr)
	GAP_BUFFER_Clear( buf->mBuffer )
	buf->mcurrow = 0	
	buf->mrowcount = 0
	buf->mmaxrows = 0
end sub

function EDIT_BUFFER_GetBufferSize alias "EDIT_BUFFER_GetBufferSize" (byval buf as EDIT_BUFFER_T ptr) As integer	
	function = GAP_BUFFER_GetBufferSize( buf->mBuffer )
end function

sub EDIT_BUFFER_SetBufferSize alias "EDIT_BUFFER_SetBufferSize" (byval buf as EDIT_BUFFER_T ptr, byval size As integer)
	GAP_BUFFER_SetBufferSize( buf->mBuffer, size )
end sub

function EDIT_BUFFER_GetLength alias "EDIT_BUFFER_GetLength" (byval buf as EDIT_BUFFER_T ptr) As integer
	function = GAP_BUFFER_GetLength( buf->mBuffer )
end function

function EDIT_BUFFER_GetIndex alias "EDIT_BUFFER_GetIndex" (byval buf as EDIT_BUFFER_T ptr) As integer
	function = GAP_BUFFER_GetIndex( buf->mBuffer )
end function

sub EDIT_BUFFER_SetIndex alias "EDIT_BUFFER_SetIndex" (byval buf as EDIT_BUFFER_T ptr, byval Index As integer)
	GAP_BUFFER_SetIndex buf->mBuffer, Index
end sub

sub EDIT_BUFFER_InsertChar alias "EDIT_BUFFER_InsertChar" (byval buf as EDIT_BUFFER_T Ptr, byval ch As Integer)
end sub

sub EDIT_BUFFER_BackChar alias "EDIT_BUFFER_BackChar" (byval buf as EDIT_BUFFER_T Ptr)
end sub

sub EDIT_BUFFER_DeleteChar alias "EDIT_BUFFER_DeleteChar" (byval buf as EDIT_BUFFER_T Ptr)
end sub

function EDIT_BUFFER_GetChar alias "EDIT_BUFFER_GetChar" (byval buf as EDIT_BUFFER_T Ptr, byval Index As integer) As Integer
end function

sub EDIT_BUFFER_SetChar alias "EDIT_BUFFER_SetChar" (byval buf as EDIT_BUFFER_T Ptr, byval Index As integer, byval ch As Integer)
end sub

function EDIT_BUFFER_GetText alias "EDIT_BUFFER_GetText" (byval buf as EDIT_BUFFER_T Ptr, ByVal txt as ubyte ptr, ByVal size as integer) as integer
end function

function EDIT_BUFFER_SetText alias "EDIT_BUFFER_SetText" (byval buf as EDIT_BUFFER_T Ptr, ByVal txt as ubyte ptr, ByVal size as integer) as integer
end function

sub EDIT_BUFFER_ClearChanged alias "EDIT_BUFFER_ClearChanged" (byval buf as EDIT_BUFFER_T Ptr)
end sub

function EDIT_BUFFER_IsChanged alias "EDIT_BUFFER_IsChanged" (byval buf as EDIT_BUFFER_T Ptr) as integer
end function
