#ifndef __INCLUDE_JM_GUI_BASE_BI__
#define __INCLUDE_JM_GUI_BASE_BI__


''  Copyright (C) 2005-2007, Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.


' -------------------------------------------------------------------
' BASE UI TYPES
' -------------------------------------------------------------------

#ifndef __JM_GUI_BASE_TYPES_DEFINED__
#define __JM_GUI_BASE_TYPES_DEFINED__

Type UI_POINT_T
  x As Integer
  y As Integer
End Type

Type UI_RECT_T
  x As Integer
  y As Integer
  w As Integer
  h As Integer
End Type

Type UI_MSG_DATA_T
  mX As Integer
  mY As Integer
  mW AS Integer
  mB As Integer
  ky As Integer
End Type

Type UI_BOX_PTR As Any Ptr

#define BOXPROC_FUNC_T Function(ByVal this_ As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer

#endif '' __JM_GUI_BASE_TYPES_DEFINED__

' -------------------------------------------------------------------
' UI ELEMENT MESSAGES
' -------------------------------------------------------------------

Enum UI_MESSAGES
  UI_MSG_NONE = 0
  UI_MSG_CREATE
  UI_MSG_DESTROY
	UI_MSG_MOVE
	UI_MSG_SIZE
  UI_MSG_PAINT
  UI_MSG_KEYPRESS
''  UI_MSG_GOTFOCUS
''  UI_MSG_LOSTFOCUS
  UI_MSG_MOUSE_DOWN
  UI_MSG_MOUSE_UP
  UI_MSG_MOUSE_MOVE
''  UI_MSG_MOUSE_OVER
''  UI_MSG_MOUSE_ENTER
''  UI_MSG_MOUSE_LEAVE
  UI_MSG_MOUSE_CLICK
	
	UI_MSG_CHANGE

End Enum

' -------------------------------------------------------------------
' UI ELEMENT ORDER TYPES
' -------------------------------------------------------------------

Enum UI_ORDER_TYPES
  UI_ORDER_BOTTOM = -2
  UI_ORDER_DOWN = -1
  UI_ORDER_NO_CHANGE = 0
  UI_ORDER_UP = 1
  UI_ORDER_TOP = 2
End Enum

' -------------------------------------------------------------------
' UI ELEMENT FLAGS
' -------------------------------------------------------------------

Const UI_BOX_FLAG_VISIBLE As Integer  = &h1
Const UI_BOX_FLAG_DISABLED As Integer = &h2
Const UI_BOX_FLAG_DOWN As Integer     = &h4
Const UI_BOX_FLAG_ROOT As Integer     = &h8000000
Const UI_BOX_FLAG_DRAG                = &H8

Const UI_BOX_FLAG_NORMAL = UI_BOX_FLAG_VISIBLE

#ifndef FALSE
Const FALSE = 0
#endif
#ifndef TRUE
Const True = Not FALSE
#endif
#ifndef NULL
Const NULL = 0
#endif

' -------------------------------------------------------------------
' RECT FUNTIONS
' -------------------------------------------------------------------
Declare Function UI_SetRect alias "UI_SetRect" ( byval rec As UI_RECT_T Ptr, byval x As Integer, byval y As Integer, byval w As Integer, byval h As integer ) As Integer
Declare Function UI_SetRectEmpty alias "UI_SetRectEmpty" ( byval rec As UI_RECT_T Ptr ) As Integer
Declare Function UI_CopyRect alias "UI_CopyRect" ( byval dst As UI_RECT_T Ptr, byval src As UI_RECT_T Ptr ) As Integer
Declare Function UI_OffsetRect alias "UI_OffsetRect" ( byval rec As UI_RECT_T Ptr, byval dx As Integer, byval dy As Integer ) As Integer
Declare Function UI_PositionRect alias "UI_PositionRect" ( byval rec As UI_RECT_T Ptr, byval x As Integer, byval y As Integer ) As Integer
Declare Function UI_ResizeRect alias "UI_ResizeRect" ( byval rec As UI_RECT_T Ptr, byval w As Integer, byval h As Integer ) As Integer
Declare Function UI_SizeRect alias "UI_SizeRect" ( byval rec As UI_RECT_T Ptr ) As Integer
Declare Function UI_InflateRect alias "UI_InflateRect" ( byval rec As UI_RECT_T Ptr, byval dx As Integer, byval dy As Integer ) As Integer
Declare Function UI_IsPointInRect alias "UI_IsPointInRect"  (byval rec AS UI_RECT_T Ptr, byval x AS Integer, byval y AS Integer) as Integer

' -------------------------------------------------------------------
' UI MANAGER
' -------------------------------------------------------------------

Declare Sub UI_UpdateScreenInfo alias "UI_UpdateScreenInfo" (byval w as long, byval h as long, byval d as long)
Declare Sub UI_Close alias "UI_Close" ()

Declare Function UI_CreateBox alias "UI_CreateBox" (byval ownerbox As UI_BOX_PTR, _
  byval boxType As Integer, byval id As Integer, byval x As Integer, byval y As Integer, byval w As Integer, byval h As Integer, _
  ByVal BoxProc As BOXPROC_FUNC_T, _
  ByVal DefProc As BOXPROC_FUNC_T, _
  ByVal ExtraBytes As Integer, ByVal flags As Integer ) As UI_BOX_PTR

Declare Function UI_GetRoot alias "UI_GetRoot" () As UI_BOX_PTR

Declare Function UI_DeleteBox alias "UI_DeleteBox" (byval box As UI_BOX_PTR) As Integer

Declare Function UI_ShowBox alias "UI_ShowBox" (byval box As UI_BOX_PTR) As Integer
Declare Function UI_HideBox alias "UI_HideBox" (byval box As UI_BOX_PTR) As Integer
Declare Function UI_EnableBox alias "UI_EnableBox" (byval box As UI_BOX_PTR) As Integer
Declare Function UI_DisableBox alias "UI_DisableBox" (byval box As UI_BOX_PTR) As Integer

Declare Function UI_SetBoxOrder alias "UI_SetBoxOrder" (byval box As UI_BOX_PTR, byval Order As Integer) As Integer
Declare Function UI_GetBoxExtraBytesPtr alias "UI_GetBoxExtraBytesPtr" (byval box As UI_BOX_PTR) As Any Ptr
Declare Function UI_GetBoxDataPtr alias "UI_GetBoxDataPtr" (byval box As UI_BOX_PTR) As Any Ptr
Declare Function UI_SetBoxDataPtr alias "UI_SetBoxDataPtr" (byval box As UI_BOX_PTR, byval ExtraPtr as Any Ptr) As Any Ptr

Declare Function UI_GetParentBox alias "UI_GetParentBox" (byval box As UI_BOX_PTR) As UI_BOX_PTR
Declare Function UI_GetBoxID alias "UI_GetBoxID" (byval box As UI_BOX_PTR) as integer
Declare Function UI_GetBoxFromID alias "UI_GetBoxFromID" (byval box As UI_BOX_PTR, ByVal id As Integer) As UI_BOX_PTR

' -------------------------------------------------------------------
' UI HELPERS
' -------------------------------------------------------------------

Declare Function UI_PositionBox alias "UI_PositionBox" (byval box As UI_BOX_PTR, byval x As integer, byval y As integer) As Integer
Declare Function UI_MoveBox alias "UI_MoveBox" (byval box As UI_BOX_PTR, byval x As integer, byval y As integer, byval w As integer, byval h As integer) As Integer
Declare Function UI_ResizeBox alias "UI_ResizeBox" (byval box As UI_BOX_PTR, byval w As integer, byval h As integer) As Integer

Declare Sub UI_SetCaption alias "UI_SetCaption" (byval box As UI_BOX_PTR, byval s As zstring ptr)
Declare Function UI_GetCaption alias "UI_GetCaption" (byval box As UI_BOX_PTR) As zString Ptr

Declare Function UI_CallDefaultProc alias "UI_CallDefaultProc" (ByVal box As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer
Declare Function UI_CallBoxProc alias "UI_CallBoxProc" (ByVal box As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer

Declare Function UI_Setfocus alias "UI_Setfocus" (byval box As UI_BOX_PTR) As UI_BOX_PTR
Declare Function UI_GetFocus alias "UI_GetFocus" () As UI_BOX_PTR

' -------------------------------------------------------------------
' BOX COORDS
' -------------------------------------------------------------------

Declare Function UI_GetScreenCoords alias "UI_GetScreenCoords" (byval box As UI_BOX_PTR, byval rec As UI_RECT_T Ptr) As Integer
Declare Function UI_GetParentCoords alias "UI_GetParentCoords" (byval box As UI_BOX_PTR, byval rec As UI_RECT_T Ptr) As Integer
Declare Function UI_GetBoxCoords alias "UI_GetBoxCoords" (byval box As UI_BOX_PTR, byval rec As UI_RECT_T Ptr) As Integer
Declare Function UI_GetBoxFromXY alias "UI_GetBoxFromXY" (byval box As UI_BOX_PTR, byval x AS Integer, byval y AS Integer) As UI_BOX_PTR

' -------------------------------------------------------------------
' UI INPUT
' -------------------------------------------------------------------

Declare Function UI_GetMouseCoords alias "UI_GetMouseCoords" (ByRef x As Integer, ByRef y As Integer) As Integer
Declare Function UI_UpdateMouseInfo alias "UI_UpdateMouseInfo" (byval box As UI_BOX_PTR, byval mX As Integer, byval mY As Integer, byval mW AS Integer, byval mB As Integer) As Integer
Declare Function UI_UpdateKeyInfo alias "UI_UpdateKeyInfo" (byval box As UI_BOX_PTR, byval ky As Integer) As Integer
Declare Function UI_GenerateEvent alias "UI_GenerateEvent" () As Integer

Declare Function UI_SetCapture alias "UI_SetCapture" (byval box As UI_BOX_PTR) As UI_BOX_PTR
Declare Function UI_ReleaseCapture alias "UI_ReleaseCapture" () As Integer
Declare Function UI_GetCapture alias "UI_GetCapture" () As UI_BOX_PTR

Declare Function UI_BeginDrag alias "UI_BeginDrag" (byval box As UI_BOX_PTR, ByVal x As Integer, ByVal y As Integer) As UI_BOX_PTR
Declare Function UI_EndDrag alias "UI_EndDrag" (byval box As UI_BOX_PTR, ByVal x As Integer, ByVal y As Integer) As Integer
Declare Function UI_Drag alias "UI_Drag" (byval box As UI_BOX_PTR, ByVal x As Integer, ByVal y As Integer) As UI_BOX_PTR

' -------------------------------------------------------------------
' UI DRAWING 
' -------------------------------------------------------------------

Declare Function UI_Draw alias "UI_Draw" (byval box As UI_BOX_PTR, byval flags As Integer) As Integer

#endif
