#ifndef __INCLUDE_JM_LINE_BUFFER_BI__
#define __INCLUDE_JM_LINE_BUFFER_BI__

''  Copyright (C) 2005-2007, Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.

const LINE_BUFFER_FLAG_CHANGED = 1

Type LINE_BUFFER_T
	mflags as integer
	msize as integer
	mlength as integer
	mindex as integer
	mdata as ubyte Ptr
End Type


declare function LINE_BUFFER_Create alias "LINE_BUFFER_Create"        (byval maxsize as integer) as LINE_BUFFER_T Ptr
declare sub      LINE_BUFFER_Destroy alias "LINE_BUFFER_Destroy"       (byval buf as LINE_BUFFER_T Ptr)
declare sub      LINE_BUFFER_Clear alias "LINE_BUFFER_Clear"         (byval buf as LINE_BUFFER_T Ptr)
declare function LINE_BUFFER_GetBufferSize alias "LINE_BUFFER_GetBufferSize" (byval buf as LINE_BUFFER_T ptr) As integer
declare sub      LINE_BUFFER_SetBufferSize alias "LINE_BUFFER_SetBufferSize" (byval buf as LINE_BUFFER_T ptr, byval size As integer)

declare function LINE_BUFFER_GetLength alias "LINE_BUFFER_GetLength"     (byval buf as LINE_BUFFER_T Ptr) as integer
declare function LINE_BUFFER_GetIndex alias "LINE_BUFFER_GetIndex"      (byval buf as LINE_BUFFER_T Ptr) as integer
declare function LINE_BUFFER_SetIndex alias "LINE_BUFFER_SetIndex"      (byval buf as LINE_BUFFER_T Ptr, byval index as integer) as integer

declare sub      LINE_BUFFER_InsertChar alias "LINE_BUFFER_InsertChar"    (byval buf as LINE_BUFFER_T Ptr, byval ch as integer)
declare sub      LINE_BUFFER_BackChar alias "LINE_BUFFER_BackChar"      (byval buf as LINE_BUFFER_T Ptr)
declare sub      LINE_BUFFER_DeleteChar alias "LINE_BUFFER_DeleteChar"    (byval buf as LINE_BUFFER_T Ptr)
declare function LINE_BUFFER_GetChar alias "LINE_BUFFER_GetChar"       (byval buf as LINE_BUFFER_T Ptr, byval Index As integer) As Integer
declare sub      LINE_BUFFER_SetChar alias "LINE_BUFFER_SetChar"       (byval buf as LINE_BUFFER_T Ptr, byval Index As integer, byval ch As Integer)
declare function LINE_BUFFER_GetTextPtr alias "LINE_BUFFER_GetTextPtr"    (byval buf as LINE_BUFFER_T Ptr) as zstring ptr
declare function LINE_BUFFER_GetText alias "LINE_BUFFER_GetText"       (byval buf as LINE_BUFFER_T Ptr, ByVal txt as ubyte ptr, ByVal size as integer) as integer
declare function LINE_BUFFER_SetText alias "LINE_BUFFER_SetText"       (byval buf as LINE_BUFFER_T Ptr, ByVal txt as ubyte ptr, ByVal size as integer) as integer

declare sub      LINE_BUFFER_ClearChanged alias "LINE_BUFFER_ClearChanged"  (ByVal buf as LINE_BUFFER_T Ptr)
declare function LINE_BUFFER_IsChanged alias "LINE_BUFFER_IsChanged"     (ByVal buf as LINE_BUFFER_T Ptr) as integer
#endif
