''  jm_image.bas - jm_gui
''	Copyright (C) 2005-2007 Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.
''

#include "crt/string.bi"
#include "jm_image.bi"

Function IMAGE_Create alias "IMAGE_Create" (byval w as integer, byval h as integer, byval clr as integer, byval bitdepth as integer) as any ptr
	dim img as short ptr, dst as any ptr
	dim as integer s,i,bpp

	if (bitdepth=8) then 
		bpp = 1
	elseif (bitdepth=16) then 
		bpp = 2
	elseif ((bitdepth=24) or (bitdepth=32)) then 
		bpp = 4
	else
		return NULL
	end if

	if ((w<=0) or (h<=0)) then
		return NULL
	end if

	s = w * h

	img = Allocate(w * h * bpp + 4)
	if (img) then
		dst = img + 2
		img[0] = (w shl 3) or bpp
		img[1] = h
		if (bpp=1) then
			for i=0 to s-1
				cast(byte ptr, dst)[i] = clr and 255
			next i
		elseif (bpp=2) then
			for i=0 to s-1
				cast(short ptr, dst)[i] = clr and &hffff
			next i
		elseif (bpp=4) then
			for i=0 to s-1
				cast(integer ptr, dst)[i] = clr
			next i
		end if
	endif
	return img	
end function

sub IMAGE_Destroy alias "IMAGE_Destroy" (byval img as any ptr)
	Deallocate img
end sub

sub IMAGE_pset alias "IMAGE_pset" (byval img as any ptr, byval x as integer, byval y as integer, byval clr as integer)
	if (img) then
		dim w as ushort = Cast(ushort ptr, img)[0] shr 3
		dim h as ushort = Cast(ushort ptr, img)[1]
		dim d as ushort = Cast(ushort ptr, img)[0] and 7
		if ((x >= 0) and (y >=0) and (x < w) and (y < h)) then
			if (d=1) then
				cast(byte ptr, img)[w * y + x + 4] = clr
			elseif (d=2) then
				cast(short ptr, img)[w * y + x + 2] = clr
			elseif (d=4) then
				cast(integer ptr, img)[w * y + x + 1] = clr
			endif
		endif
	endif
end sub

function IMAGE_pget alias "IMAGE_pget" (byval img as any ptr, byval x as integer, byval y as integer) as integer
	function = 0
	if (img) then
		dim w as ushort = Cast(ushort ptr, img)[0] shr 3
		dim h as ushort = Cast(ushort ptr, img)[1]
		dim d as ushort = Cast(ushort ptr, img)[0] and 7
		if ((x >= 0) and (y >=0) and (x < w) and (y < h)) then
			if (d=1) then
				function = cast(byte ptr, img)[w * y + x + 4]
			elseif (d=2) then
				function = cast(short ptr, img)[w * y + x + 2]
			elseif (d=4) then
				function = cast(integer ptr, img)[w * y + x + 1]
			endif
		endif
	endif
end function
