#ifndef __INCLUDE_JM_STRING_H__
#define __INCLUDE_JM_STRING_H__

/*
''  Copyright (C) 2005-2007, Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.
*/

#ifndef NULL
#define NULL 0
#endif

char * zstr_Alloc(int size);
char * zstr_Free(char * s);
int    zstr_Len(char * s);
char * zstr_Copy(char * dst, char * src);
char * zstr_CopyN(char * dst, char * src, int size);

typedef char * DSTR;
void dstr_Free(DSTR p);
DSTR dstr_AllocNew(int maxsize);
DSTR dstr_AllocCopyZ(char * s);
DSTR dstr_AssignZ(DSTR p, char * s);

void mstr_Copy(void * dst, void * src, int bytes);
void mstr_Move(void * dst, void * src, int bytes);
void mstr_Clear(void * dst, int bytes);
void mstr_Fill(void * dst, int bytes, int ch);

#endif
